/***********************************************************************/
/*                                                                     */
/*  FILE        :walk_02.c                                             */
/*  DATE        :Tue, Feb 14, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	
-------------------------------------------------------------------------
2006-02-14 : vOJn
************************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

#define		STEP		6		//sp^[Xebv

#define		SERVO_STEP	128		//T[{[^1V[PXɂڍsiK

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
// sp^[
const int SequenceTable[STEP][8] = {
//	G						r		EG		E		E		Er
	{0,		150,	-570,	300,	0,		150,	570,	-300},	//step1
	{-125,	150,	-570,	300,	-400,	150,	570,	-300},	//step2
	{-125,	-150,	-570,	300,	-400,	-150,	570,	-300},	//step3
	{0,		-150,	-570,	300,	0,		-150,	570,	-300},	//step4
	{400,	-150,	-570,	300,	125,	-150,	570,	-300},	//step5
	{400,	150,	-570,	300,	125,	150,	570,	-300},	//step6
};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// T[{[^̒_iJEglj/_l1500s  200ns = 7500
unsigned int	HomePos[8]	=	{7400	//P60,G
								,7500	//P61,
								,7350	//P62,
								,7500	//P63,r
								,7250	//P64,EG
								,7650	//P65,E
								,7750	//P66,E
								,7400	//P67,Er
								};
// T[{[^̈ʒuipXC_́}ʕbj
int				ServoPos[8]	=	{0,0,0,0,0,0,0,0};
// T[{[^̌݃JEgl
long			ServoCnt[8];	//16rbg^C}ZɃZbg
// T[{[^̖ڕWJEgl
long			GoalCnt[8];
// T[{[^JEglڍs1iKZl
long			Add1Step[8];
// T[{[^JEglڍsJE^
unsigned int	MoveCnt;
// T[{[^JEglڍs̃V[PX
unsigned char	SequenceStage	=	0;	// 0:~
										// 1:ڍs
										// 2:I

/************************************************************************
	֐̒`
************************************************************************/
void			init_servo(void);
void			init_tmz(void);
void			intprog_tmz0(void);
void			main(void);
void			servo_set(void);
void			wait(void);

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	int i,j;

	// CjVCY ----------------------------------------------------
	init_tmz();
	init_servo();

	// C[v -----------------------------------------------------
	while(1){
		for (i=0; i<STEP; i++){
			for (j=0; j<8; j++){
				ServoPos[j] = SequenceTable[i][j];
			}
			servo_set();
			while(SequenceStage<2){nop();}
		}
	}
}

/************************************************************************
	T[{[^ CjVCY
************************************************************************/
void init_servo(void)
{
	int i;

	for (i=0; i<8; i++){
		ServoCnt[i] = HomePos[i] * 0x10000;
	}
}

/************************************************************************
	T[{[^f[^Zbg
************************************************************************/
void servo_set(void)
{
	int i;

	for (i=0; i<8; i++){
		GoalCnt[i] = (HomePos[i] + ServoPos[i] * 5) * 0x10000;
		Add1Step[i] = (GoalCnt[i] - ServoCnt[i]) / SERVO_STEP;
	}

	MoveCnt = SERVO_STEP;
	SequenceStage = 1;
}

/************************************************************************
	^C}Z CjVCY
************************************************************************/
void init_tmz(void)
{
	TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~

	TZ0.TCR.BYTE	=	0xe2;	//NA,/4
	TZ1.TCR.BYTE	=	0xe2;	//NA,/4

	TZ.TMDR.BYTE	=	0x0f;	//TCNT0,1͓

	TZ.TOCR.BYTE	=	0xff;	//o=1

	TZ.TOER.BYTE	=	0x00;	//o͒[qCl[u

	TZ0.TIORA.BYTE	=	0x99;	//GRA,GRB̓RyA}b`0o
	TZ0.TIORC.BYTE	=	0x99;	//GRC,GRD̓RyA}b`0o
	TZ1.TIORA.BYTE	=	0x99;	//GRA,GRB̓RyA}b`0o
	TZ1.TIORC.BYTE	=	0x99;	//GRC,GRD̓RyA}b`0o

	TZ0.TSR.BYTE	=	0x00;	//݃tONA
	TZ1.TSR.BYTE	=	0x00;	//݃tONA

	TZ0.TIER.BYTE	=	0x10;	//I[o[t[C^[vgCl[u
	TZ1.TIER.BYTE	=	0x00;	//C^vgfBZ[u

	TZ0.GRA			=	HomePos[0];	//JEgl
	TZ0.GRB			=	HomePos[1];	//JEgl
	TZ0.GRC			=	HomePos[2];	//JEgl
	TZ0.GRD			=	HomePos[3];	//JEgl
	TZ1.GRA			=	HomePos[4];	//JEgl
	TZ1.GRB			=	HomePos[5];	//JEgl
	TZ1.GRC			=	HomePos[6];	//JEgl
	TZ1.GRD			=	HomePos[7];	//JEgl

	TZ0.TCNT		=	0x0000;	//TCNT0=0
	TZ1.TCNT		=	0x0000;	//TCNT1=0

	TZ.TSTR.BYTE	=	0x03;	//TCNT0,1 JEgX^[g
}

/************************************************************************
	^C}Z `l0 
************************************************************************/
#pragma regsave (intprog_tmz0)
void intprog_tmz0(void)
{
	int i;

	//^C}Z I[ot[C^[vgtO NA
	TZ0.TSR.BIT.OVF =0;

	//TCNT0,1 ~
	TZ.TSTR.BYTE = 0x00;

	//JEgl̉Z
	if (SequenceStage==1){
		for (i=0; i<8; i++){
			ServoCnt[i] = ServoCnt[i] + Add1Step[i];
		}
		MoveCnt--; if (MoveCnt==0) {SequenceStage = 2;}
	}

	//^C}ZɃJEglZbg
	TZ0.GRA = ServoCnt[0] / 0x10000;
	TZ0.GRB = ServoCnt[1] / 0x10000;
	TZ0.GRC = ServoCnt[2] / 0x10000;
	TZ0.GRD = ServoCnt[3] / 0x10000;
	TZ1.GRA = ServoCnt[4] / 0x10000;
	TZ1.GRB = ServoCnt[5] / 0x10000;
	TZ1.GRC = ServoCnt[6] / 0x10000;
	TZ1.GRD = ServoCnt[7] / 0x10000;

	//o͂1ɂ
	TZ.TOCR.BYTE = 0xff;

	//TCNT0,1 JEgX^[g
	TZ0.TCNT = 0x0000;
	TZ1.TCNT = 0x0000;
	TZ.TSTR.BYTE = 0x03;
}

/************************************************************************
	EFCg(1000ms)
************************************************************************/
void wait(void)
{
	unsigned long i;

	for (i=0;i<3333333;i++){}
}
